



<!DOCTYPE html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
        <meta name="description" content="我的技术笔记本~">
      
      
      
        <meta name="author" content="chenyuan">
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-0.17.2, mkdocs-material-2.5.3">
    
    
      
        <title>JavaScript - notebook</title>
      
    
    
      <link rel="stylesheet" href="../assets/stylesheets/application.aa3de92b.css">
      
    
    
      <script src="../assets/javascripts/modernizr.1aa3b519.js"></script>
    
    
      
        <link rel="stylesheet" href="https://fonts.loli.net/css?family=Roboto:300,400,400i,700|Roboto+Mono">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
      <link rel="stylesheet" href="https://fonts.loli.net/icon?family=Material+Icons">
    
    
    
  </head>
  
  
    <body dir="ltr">
  
    <svg class="md-svg">
      <defs>
        
        
          <svg xmlns="http://www.w3.org/2000/svg" width="416" height="448" viewBox="0 0 416 448" id="github"><path fill="currentColor" d="M160 304q0 10-3.125 20.5t-10.75 19T128 352t-18.125-8.5-10.75-19T96 304t3.125-20.5 10.75-19T128 256t18.125 8.5 10.75 19T160 304zm160 0q0 10-3.125 20.5t-10.75 19T288 352t-18.125-8.5-10.75-19T256 304t3.125-20.5 10.75-19T288 256t18.125 8.5 10.75 19T320 304zm40 0q0-30-17.25-51T296 232q-10.25 0-48.75 5.25Q229.5 240 208 240t-39.25-2.75Q130.75 232 120 232q-29.5 0-46.75 21T56 304q0 22 8 38.375t20.25 25.75 30.5 15 35 7.375 37.25 1.75h42q20.5 0 37.25-1.75t35-7.375 30.5-15 20.25-25.75T360 304zm56-44q0 51.75-15.25 82.75-9.5 19.25-26.375 33.25t-35.25 21.5-42.5 11.875-42.875 5.5T212 416q-19.5 0-35.5-.75t-36.875-3.125-38.125-7.5-34.25-12.875T37 371.5t-21.5-28.75Q0 312 0 260q0-59.25 34-99-6.75-20.5-6.75-42.5 0-29 12.75-54.5 27 0 47.5 9.875t47.25 30.875Q171.5 96 212 96q37 0 70 8 26.25-20.5 46.75-30.25T376 64q12.75 25.5 12.75 54.5 0 21.75-6.75 42 34 40 34 99.5z"/></svg>
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="drawer">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="search">
    <label class="md-overlay" data-md-component="overlay" for="drawer"></label>
    
      <a href="#localstorage" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href="../README/" title="notebook" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            
              <span class="md-header-nav__topic">
                notebook
              </span>
              <span class="md-header-nav__topic">
                JavaScript
              </span>
            
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          
            <label class="md-icon md-icon--search md-header-nav__button" for="search"></label>
            
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
          
        
      </div>
      
        <div class="md-flex__cell md-flex__cell--shrink">
          <div class="md-header-nav__source">
            


  


  <a href="https://github.com/zjuchenyuan/notebook/" title="Go to repository" class="md-source" data-md-source="github">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#github" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      GitHub
    </div>
  </a>

          </div>
        </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
      <main class="md-main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="drawer">
    <span class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </span>
    notebook
  </label>
  
    <div class="md-nav__source">
      


  


  <a href="https://github.com/zjuchenyuan/notebook/" title="Go to repository" class="md-source" data-md-source="github">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#github" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      GitHub
    </div>
  </a>

    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href="../README/" title="Home" class="md-nav__link">
      Home
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2" type="checkbox" id="nav-2">
    
    <label class="md-nav__link" for="nav-2">
      Python
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-2">
        Python
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Python/" title="Python" class="md-nav__link">
      Python
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../gist/" title="Gist Python一些常用代码片段" class="md-nav__link">
      Gist Python一些常用代码片段
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3" type="checkbox" id="nav-3" checked>
    
    <label class="md-nav__link" for="nav-3">
      Programming Languages
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-3">
        Programming Languages
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../BASH/" title="BASH" class="md-nav__link">
      BASH
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../BAT/" title="BAT批处理" class="md-nav__link">
      BAT批处理
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../C/" title="C语言" class="md-nav__link">
      C语言
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3-4" type="checkbox" id="nav-3-4">
    
    <label class="md-nav__link" for="nav-3-4">
      Java
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-3-4">
        Java
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Java/" title="Java" class="md-nav__link">
      Java
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../S2-045/" title="S2-045" class="md-nav__link">
      S2-045
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="toc">
    
    
      <label class="md-nav__link md-nav__link--active" for="toc">
        JavaScript
      </label>
    
    <a href="./" title="JavaScript" class="md-nav__link md-nav__link--active">
      JavaScript
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#localstorage" title="使用localStorage" class="md-nav__link">
    使用localStorage
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#phantomjs" title="使用phantomjs爬取网页" class="md-nav__link">
    使用phantomjs爬取网页
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#jqueryshow" title="jQuery劫持show事件" class="md-nav__link">
    jQuery劫持show事件
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#get" title="读取GET参数" class="md-nav__link">
    读取GET参数
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#github-issue" title="使用 Github Issue 作为博客评论区" class="md-nav__link">
    使用 Github Issue 作为博客评论区
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#historyreplacestate" title="history.replaceState修改历史记录" class="md-nav__link">
    history.replaceState修改历史记录
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#checkboxlocalstorage" title="记住一个checkbox的状态（用localStorage）" class="md-nav__link">
    记住一个checkbox的状态（用localStorage）
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#nodejs" title="NodeJS" class="md-nav__link">
    NodeJS
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#dockernpm" title="用Docker执行npm" class="md-nav__link">
    用Docker执行npm
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
    </ul>
  
</nav>
    
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../PHP/" title="PHP" class="md-nav__link">
      PHP
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-4" type="checkbox" id="nav-4">
    
    <label class="md-nav__link" for="nav-4">
      Web
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-4">
        Web
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../CDN/" title="CDN" class="md-nav__link">
      CDN
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../cURL/" title="cURL" class="md-nav__link">
      cURL
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-4-3" type="checkbox" id="nav-4-3">
    
    <label class="md-nav__link" for="nav-4-3">
      Favorites
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-4-3">
        Favorites
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Favorites/" title="Favorites" class="md-nav__link">
      Favorites
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../GithubProjectRecommendation/" title="Github Project Recommendation" class="md-nav__link">
      Github Project Recommendation
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Links/" title="更多链接" class="md-nav__link">
      更多链接
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Flask/" title="Flask" class="md-nav__link">
      Flask
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../MySQL/" title="MySQL" class="md-nav__link">
      MySQL
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Nginx/" title="Nginx" class="md-nav__link">
      Nginx
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../RabbitMQ/" title="RabbitMQ" class="md-nav__link">
      RabbitMQ
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-5" type="checkbox" id="nav-5">
    
    <label class="md-nav__link" for="nav-5">
      Development
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-5">
        Development
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Developer/" title="Developer" class="md-nav__link">
      Developer
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Docker/" title="Docker" class="md-nav__link">
      Docker
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Git/" title="Git" class="md-nav__link">
      Git
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Jekyll/" title="Jekyll" class="md-nav__link">
      Jekyll
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../WindowsSoftware/" title="WindowsSoftware" class="md-nav__link">
      WindowsSoftware
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-6" type="checkbox" id="nav-6">
    
    <label class="md-nav__link" for="nav-6">
      Linux
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-6">
        Linux
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-backup/" title="Linux-backup" class="md-nav__link">
      Linux-backup
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-setup/" title="Linux-setup" class="md-nav__link">
      Linux-setup
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-SSH/" title="Linux-SSH" class="md-nav__link">
      Linux-SSH
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-cli/" title="Linux-cli" class="md-nav__link">
      Linux-cli
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-VirtualBox/" title="Linux-VirtualBox" class="md-nav__link">
      Linux-VirtualBox
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Ubuntu/" title="Ubuntu" class="md-nav__link">
      Ubuntu
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-7" type="checkbox" id="nav-7">
    
    <label class="md-nav__link" for="nav-7">
      My Projects
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-7">
        My Projects
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../zjugrshelper/" title="ZJU grs helper" class="md-nav__link">
      ZJU grs helper
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#localstorage" title="使用localStorage" class="md-nav__link">
    使用localStorage
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#phantomjs" title="使用phantomjs爬取网页" class="md-nav__link">
    使用phantomjs爬取网页
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#jqueryshow" title="jQuery劫持show事件" class="md-nav__link">
    jQuery劫持show事件
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#get" title="读取GET参数" class="md-nav__link">
    读取GET参数
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#github-issue" title="使用 Github Issue 作为博客评论区" class="md-nav__link">
    使用 Github Issue 作为博客评论区
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#historyreplacestate" title="history.replaceState修改历史记录" class="md-nav__link">
    history.replaceState修改历史记录
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#checkboxlocalstorage" title="记住一个checkbox的状态（用localStorage）" class="md-nav__link">
    记住一个checkbox的状态（用localStorage）
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#nodejs" title="NodeJS" class="md-nav__link">
    NodeJS
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#dockernpm" title="用Docker执行npm" class="md-nav__link">
    用Docker执行npm
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                  <a href="https://github.com/zjuchenyuan/notebook/edit/master/JavaScript.md" title="Edit this page" class="md-icon md-content__icon">&#xE3C9;</a>
                
                
                  <h1>JavaScript</h1>
                
                <h2 id="localstorage">使用localStorage<a class="headerlink" href="#localstorage" title="Permanent link">&para;</a></h2>
<p>Cookie存数据影响访问速度(每次请求都需要带上Cookie)，使用localStorage存储有更大容量，还不易丢失</p>
<p>建议将用户的大段输入随时存储到localStorage中</p>
<p>高级应用可以是把js等代码文件这样缓存到本地，安全性讨论见<a href="https://imququ.com/post/enhance-security-for-ls-code.html"><a href="https://imququ.com/post/enhance-security-for-ls-code.html">https://imququ.com/post/enhance-security-for-ls-code.html</a></a></p>
<div class="codehilite"><pre><span></span>//写入
var storage=window.localStorage;
storage[&quot;a&quot;]=1;
//清空
window.localStorage.clear();
</pre></div>


<hr />
<h2 id="phantomjs">使用phantomjs爬取网页<a class="headerlink" href="#phantomjs" title="Permanent link">&para;</a></h2>
<p>有些时候我们用Python的requests并不能很完美地渲染好网页，例如人家用酷炫的js作图了，我就想得到这张图，这时候用phantomjs就好啦</p>
<p>爬取目标：</p>
<p><a href="http://oncokb.org/#/gene/AKT1"><a href="http://oncokb.org/#/gene/AKT1">http://oncokb.org/#/gene/AKT1</a></a></p>
<p>这个网页的右边有一张Tumor Types with AKT1 Mutations的图</p>
<p>代码：</p>
<p><a href="../code/spider.oncokb.js">code/spider.oncokb.js</a></p>
<p>代码的细节：</p>
<ol>
<li>
<p>打开页面之前为了截图方便需要先设置浏览器的大小，这里设置为了1920*1080</p>
</li>
<li>
<p>不要一打开页面就截图，而是等到页面加载好了最后一个请求(从Chrome开发人员工具查看最后的请求是啥)后，再等待5s后执行截图、导出HTML并退出</p>
</li>
<li>
<p>为了防止无限等待，设置最长2min后timeout退出</p>
</li>
<li>
<p>为了方便批量化处理，从命令行参数读取需要爬取的基因名称</p>
</li>
<li>
<p>在运行的时候有设置代理和不要载入图片的参数，具体见<a href="http://phantomjs.org/api/command-line.html">官方文档</a></p>
</li>
</ol>
<hr />
<h2 id="jqueryshow">jQuery劫持show事件<a class="headerlink" href="#jqueryshow" title="Permanent link">&para;</a></h2>
<p>我的需求：用户登录的div需要点击Login后显示(toggle)，此时浏览器已经自动帮用户填上了用户名和密码，用户需要手动点击登录按钮才会触发登录请求；现在我想加入快速登录功能，在显示登录div后自动提交登录请求，如果为空或密码错误再交给用户输入</p>
<p>我的解决方案：加入下述扩展jQuery的代码后，对#login绑定beforeShow事件，处理函数先根据全局变量是否存在来判断是否执行过（防止死循环），如果没有执行过则执行登录函数clicklogin并设置全局变量</p>
<p>效果：如果浏览器自动填入了正确的用户名密码，则用户点击Login后快速闪过登录输入框即完成登录；如果浏览器没有自动填入用户名密码，clicklogin函数直接return，用户没有感知；如果浏览器填入的密码是错的，用户会看到密码错误提示，1s后再次toggle登录的div要求用户输入</p>
<p>From: <a href="http://stackoverflow.com/questions/1225102/jquery-event-to-trigger-action-when-a-div-is-made-visible">http://stackoverflow.com/questions/1225102/jquery-event-to-trigger-action-when-a-div-is-made-visible</a></p>
<p>引入jQuery后，修改jQuery自身的show函数以扩展bind：</p>
<div class="codehilite"><pre><span></span>jQuery(function($) {

  var _oldShow = $.fn.show;

  $.fn.show = function(speed, oldCallback) {
    return $(this).each(function() {
      var obj  = $(this),
          newCallback = function() {
            if ($.isFunction(oldCallback)) {
              oldCallback.apply(obj);
            }
            obj.trigger(&#39;afterShow&#39;);
          };

      // you can trigger a before show if you want
      obj.trigger(&#39;beforeShow&#39;);

      // now use the old function to show the element passing the new callback
      _oldShow.apply(obj, [speed, newCallback]);
    });
  }
});
</pre></div>


<p>然后就可以使用bind注册<code>beforeShow</code>，<code>afterShow</code>咯：</p>
<div class="codehilite"><pre><span></span>jQuery(function($) {
  $(&#39;#test&#39;)
    .bind(&#39;beforeShow&#39;, function() {
      alert(&#39;beforeShow&#39;);
    }) 
    .bind(&#39;afterShow&#39;, function() {
      alert(&#39;afterShow&#39;);
    })
    .show(1000, function() {
      alert(&#39;in show callback&#39;);
    })
    .show();
});
</pre></div>


<hr />
<h2 id="get">读取GET参数<a class="headerlink" href="#get" title="Permanent link">&para;</a></h2>
<p>有些时候对GET参数的处理交给了前端，后端的PHP可以$_GET[&ldquo;parameter&rdquo;]，前端JS咋办呢？</p>
<p>From: <a href="http://stackoverflow.com/questions/979975/how-to-get-the-value-from-the-get-parameters">http://stackoverflow.com/questions/979975/how-to-get-the-value-from-the-get-parameters</a></p>
<div class="codehilite"><pre><span></span>var QueryString = function () {
  // This function is anonymous, is executed immediately and 
  // the return value is assigned to QueryString!
  var query_string = {};
  var query = window.location.search.substring(1);
  var vars = query.split(&quot;&amp;&quot;);
  for (var i=0;i&lt;vars.length;i++) {
    var pair = vars[i].split(&quot;=&quot;);
        // If first entry with this name
    if (typeof query_string[pair[0]] === &quot;undefined&quot;) {
      query_string[pair[0]] = decodeURIComponent(pair[1]);
        // If second entry with this name
    } else if (typeof query_string[pair[0]] === &quot;string&quot;) {
      var arr = [ query_string[pair[0]],decodeURIComponent(pair[1]) ];
      query_string[pair[0]] = arr;
        // If third or later entry with this name
    } else {
      query_string[pair[0]].push(decodeURIComponent(pair[1]));
    }
  } 
  return query_string;
}();
</pre></div>


<p>执行后就可以这么使用：</p>
<div class="codehilite"><pre><span></span>if (typeof(QueryString.parameter)!=&quot;undefined&quot;) {
    alert(QueryString.parameter);//do something with the parameter
}
</pre></div>


<hr />
<h2 id="github-issue">使用 Github Issue 作为博客评论区<a class="headerlink" href="#github-issue" title="Permanent link">&para;</a></h2>
<p>人家大佬的项目：<a href="http://github.com/wzpan/comment.js"><a href="http://github.com/wzpan/comment.js">http://github.com/wzpan/comment.js</a></a>，<a href="http://www.hahack.com/codes/comment-js/">中文文档</a></p>
<p>如果觉得cloudflare加载速度不佳，可以把所有js打包成一个文件</p>
<p>效果如本博客页面底部评论区所示，为了偷懒就没有为每个md文件单独开issue了，整个blog共用一个issue</p>
<hr />
<h2 id="historyreplacestate">history.replaceState修改历史记录<a class="headerlink" href="#historyreplacestate" title="Permanent link">&para;</a></h2>
<p>如v2ex按照是否:visited来区分点开过和没点开过的帖子，其实现是url带上#reply回复数量</p>
<p>但如果帖子页面有多种进入方式（自动跳转到页尾、发起了回复等），那么url并不一定与需要的一致</p>
<p>我们可以使用history API来修改历史记录，从而保证带上<code>#reply回复数量</code>的url一定被认为访问过；而且自动改回去用户无感知（否则刷新后会打开不一样的页面）</p>
<p>代码如下：</p>
<div class="codehilite"><pre><span></span><span class="nt">&lt;script&gt;</span>
setTimeout( function(){
    var oldurl = location.href;
    history.replaceState(null, null, &#39;/t/<span class="cp">{{</span><span class="nv">topic</span><span class="o">[</span><span class="s2">&quot;id&quot;</span><span class="o">]</span><span class="cp">}}</span>#reply<span class="cp">{{</span><span class="nv">topic</span><span class="o">[</span><span class="s2">&quot;replyCount&quot;</span><span class="o">]</span><span class="cp">}}</span>&#39;);
    history.replaceState(null, null, oldurl);
}, 1000);
<span class="nt">&lt;/script&gt;</span>
</pre></div>


<hr />
<h2 id="checkboxlocalstorage">记住一个checkbox的状态（用localStorage）<a class="headerlink" href="#checkboxlocalstorage" title="Permanent link">&para;</a></h2>
<p>查询是否勾选用<code>.is(":checked")</code> ， 改变勾选状态用<code>.prop("checked",true)</code></p>
<div class="codehilite"><pre><span></span><span class="o">&lt;</span><span class="nx">script</span><span class="o">&gt;</span>
<span class="kd">function</span> <span class="nx">checkbox_onclick</span><span class="p">(){</span>
    <span class="kd">var</span> <span class="nx">checked</span> <span class="o">=</span> <span class="nx">$</span><span class="p">(</span><span class="s2">&quot;#thecheckbox&quot;</span><span class="p">).</span><span class="nx">is</span><span class="p">(</span><span class="s2">&quot;:checked&quot;</span><span class="p">);</span>
    <span class="k">if</span><span class="p">(</span><span class="nx">checked</span><span class="p">)</span> <span class="nx">localStorage</span><span class="p">.</span><span class="nx">setItem</span><span class="p">(</span><span class="s2">&quot;status_thecheckbox&quot;</span><span class="p">,</span><span class="s2">&quot;1&quot;</span><span class="p">);</span>
    <span class="k">else</span> <span class="nx">localStorage</span><span class="p">.</span><span class="nx">setItem</span><span class="p">(</span><span class="s2">&quot;status_thecheckbox&quot;</span><span class="p">,</span><span class="s2">&quot;0&quot;</span><span class="p">);</span>
<span class="p">}</span>
<span class="o">&lt;</span><span class="err">/script&gt;</span>
<span class="o">&lt;</span><span class="nx">input</span> <span class="nx">type</span><span class="o">=</span><span class="s2">&quot;checkbox&quot;</span> <span class="nx">id</span><span class="o">=</span><span class="s2">&quot;thecheckbox&quot;</span> <span class="nx">onclick</span><span class="o">=</span><span class="s1">&#39;checkbox_onclick();&#39;</span><span class="o">&gt;</span>
<span class="o">&lt;</span><span class="nx">script</span><span class="o">&gt;</span>
    <span class="kd">var</span> <span class="nx">status_thecheckbox</span> <span class="o">=</span> <span class="nx">localStorage</span><span class="p">.</span><span class="nx">getItem</span><span class="p">(</span><span class="s2">&quot;status_thecheckbox&quot;</span><span class="p">);</span>
    <span class="k">if</span><span class="p">(</span><span class="nx">status_thecheckbox</span><span class="o">!=</span><span class="kc">null</span> <span class="o">&amp;&amp;</span> <span class="nx">status_thecheckbox</span><span class="o">==</span><span class="s2">&quot;1&quot;</span><span class="p">)</span> <span class="nx">$</span><span class="p">(</span><span class="s2">&quot;#thecheckbox&quot;</span><span class="p">).</span><span class="nx">prop</span><span class="p">(</span><span class="s2">&quot;checked&quot;</span><span class="p">,</span><span class="kc">true</span><span class="p">);</span>
<span class="o">&lt;</span><span class="err">/script&gt;</span>
</pre></div>


<hr />
<h2 id="nodejs">NodeJS<a class="headerlink" href="#nodejs" title="Permanent link">&para;</a></h2>
<h3 id="dockernpm">用Docker执行npm<a class="headerlink" href="#dockernpm" title="Permanent link">&para;</a></h3>
<p>例如安装canvas和gifencoder包：</p>
<div class="codehilite"><pre><span></span>PACKAGES=&quot;canvas gifencoder&quot;
docker run --rm --volume=&quot;`pwd`:/app&quot; -w /app -it node:10 npm install <span class="cp">${</span><span class="n">PACKAGES</span><span class="cp">}</span>  --registry=https://registry.npm.taobao.org
</pre></div>
                
                  
                
              
              
                
              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../S2-045/" title="S2-045" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                S2-045
              </span>
            </div>
          </a>
        
        
          <a href="../PHP/" title="PHP" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                PHP
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            <a href=http://www.miitbeian.gov.cn/>浙ICP备15043819号-2</a>&nbsp;&nbsp;<a target=_blank href=http://www.beian.gov.cn/portal/registerSystemInfo?recordcode=33010602007826><img src="/assets/images/beian.png" height=14px>浙公网安备 33010602007826号</p></a>
          </div>
        
        powered by
        <a href="http://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
        
  <div class="md-footer-social">
    
    <link rel="stylesheet" href="https://cdnjs.loli.net/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    
      <a href="https://github.com/zjuchenyuan" class="md-footer-social__link fa fa-github-alt"></a>
    
      <a href="mailto: py3io.chenyuan@qiushi.ac.cn" class="md-footer-social__link fa fa-envelope"></a>
    
  </div>

      
    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../assets/javascripts/application.f041762f.js"></script>
      
      <script>app.initialize({version:"0.17.2",url:{base:".."}})</script>
      
        <script src="../assets/js/instantclick.min.js"></script>
      
    
    
      
    
  </body>
</html>